// CopyOnSel.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "resource.h"
#include "Options.h"

static HMODULE	g_hModule=NULL;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  reason, 
                       LPVOID lpReserved
					 )
{
	// HMODULE  DLL
	//      
	//  
	if (DLL_PROCESS_ATTACH==reason)
		g_hModule=(HMODULE)hModule;

    return TRUE;
}

/*   
 
*/
extern "C"
BOOL __declspec(dllexport) Aml_GetPluginInfo(AML_PLUGIN_INFO* p)
{
	p->nMinRelease=AP_MIN_BUILD;//   Aml Pages
	if (COptions::GetOptions().m_bEnabled)//  
		p->dwEventMask=APFEM_EDITOREVENTS;//    
	
	p->nMenuCount=1;//1  
	
	return TRUE;
}

//     
extern "C"
BOOL __declspec(dllexport) Aml_GetMenuItemInfo(UINT nIndex,AML_MENU_ITEM_INFO* p)
{
	//  
	::LoadString(g_hModule,IDS_COPYONSELMENU,p->szMenuName,sizeof(p->szMenuName));// 
	::LoadString(g_hModule,IDS_COPYONSELMENUTIP,p->szSBHint,sizeof(p->szSBHint));//   
	::LoadString(g_hModule,IDS_COPYONSELMENUTIP,p->szTTHint,sizeof(p->szTTHint));//   
	
	//    
	::strcpy(p->szFunctionName,"CopyOnSelMenuProc");
	p->nPluginType=APPT_SHOWDIALOG;// 
	
	p->dwFlags=APF_EDITMENU;//         

	if (COptions::GetOptions().m_bEnabled)//   
		p->nMenuState=MF_CHECKED;//   

	return TRUE;
}

//      
extern "C"
BOOL __declspec(dllexport) CopyOnSelMenuProc(HWND)
{
	// 
	COptions::GetOptions().m_bEnabled=!COptions::GetOptions().m_bEnabled;
	//   
	COptions::GetOptions().Write();
	//     
	APPHelper::ReReadPluginsInfo(g_hModule);
	return TRUE;
}

struct THREAD_PARAM {
	HWND hwnd;//HWND   
	CHARRANGE cr;//   	
};

bool operator==(const CHARRANGE& cr1, const CHARRANGE& cr2)
{
	return ((cr1.cpMin==cr2.cpMin) && (cr1.cpMax==cr2.cpMax));
}

DWORD __stdcall ThreadProc(LPVOID p)
{
	// 2 ,     
	Sleep(2000);
	//       
	THREAD_PARAM* const pParam=reinterpret_cast<THREAD_PARAM*>(p);
	
	if ((IsWindow(pParam->hwnd)) //   ????
		&& (COptions::GetOptions().m_bEnabled)) // ?
	{
		//     
		CHARRANGE crCur={0};
		::SendMessage(pParam->hwnd,EM_EXGETSEL,0,(LPARAM)&crCur);
		
		if (crCur==pParam->cr) {//       ?
			//      
			::SendMessage(pParam->hwnd,WM_COPY,0,0);

			//    Aml Pages
			//     (,     :)
			char szText[AML_MAX_NAME+1]={0};
			::LoadString(g_hModule,IDS_DATASENDED,szText,AML_MAX_NAME);
			APPHelper::SetStatusBarText(szText);
		}
	}//if (IsWindow(p->hwnd)) {
	
	//    
	delete pParam;
	return 0;
}

extern "C"
BOOL __declspec(dllexport) Aml_EventHandler(AML_EVENTINFO* p)
{
	BOOL bRet=TRUE;

	if ((AEC_EDITOR==p->EventCode) //   
		&& (EN_SELCHANGE==p->EventInfo.EditorEvent.nMessage)//   
		&& (p->EventInfo.EditorEvent.crSel.cpMax - p->EventInfo.EditorEvent.crSel.cpMin)//  
		&& (COptions::GetOptions().m_bEnabled))//  
	{
		// HWND   
		//   
		THREAD_PARAM* const pParam=new THREAD_PARAM;
		if (!IsBadWritePtr(pParam,sizeof(THREAD_PARAM))) {
			pParam->hwnd=p->EventInfo.EditorEvent.hwnd;
			pParam->cr=p->EventInfo.EditorEvent.crSel;
			DWORD id;
			const HANDLE hThread=CreateThread(NULL,0,ThreadProc,(void*)pParam,0,&id);
			if (hThread)//  
				CloseHandle(hThread);			
		}//if (!IsBadWritePtr(pParam,sizeof(THREAD_PARAM))) {
	}//	if ((AEC_EDITOR==p->EventCode) 

	return TRUE;
}